package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallSearchLogApplicationService;
import com.jeesharp.business.modules.mall.dto.MallSearchLogSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallSearchLogInfoVO;
import com.jeesharp.business.modules.mall.vo.MallSearchLogListVO;
import com.jeesharp.business.modules.mall.vo.MallSearchLogQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;
import java.util.List;
import java.util.Map;

/**
 * 搜索历史管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/searchLog/v1")
@Tag(name = "搜索历史管理")
@AllArgsConstructor
public class MallSearchLogController extends BaseController {

    private final MallSearchLogApplicationService mallSearchLogApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallSearchLogInfoVO> info(@RequestParam("id") String id) {
        MallSearchLogInfoVO vo = mallSearchLogApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallSearchLogListVO>> list(@RequestBody MallSearchLogQueryVO query) {
        PageRespVO<MallSearchLogListVO> page = mallSearchLogApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallSearchLogSaveDTO dto) {
        mallSearchLogApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallSearchLogApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }

    @Operation(summary = "获取热门搜索词")
    @GetMapping(value = "hotWords")
    public AjaxResult<List<Map<String, Object>>> getHotWords() {
        List<Map<String, Object>> hotWords = mallSearchLogApplicationService.getHotSearchWords();
        return AjaxResult.okData(hotWords);
    }
}
